import java.util.Random;
/**
 * Class DoubleStuff fills and sorts double array A.
 * 
 * @author RR
 * @version 2002/10/27
 */
public class DoubleStuff
{
    private int theLength;
    private double[] a;

/**
 * Constructor
 * 
 * @param aLength length of array
*/
    public DoubleStuff(int aLength) 
    { 
       a = new double[aLength];
    }
 
 /**
 * Accessor
 * 
 * @param i the index to return
 * @return the array value at position i
*/     
    public double position(int i)
    {    
        return a[i];
     }
    /**
     * findMaximum
     * 
     * @param  aSize   the current size of a
     * 
     *  @return min position of the maximum value 
     */

    
    public int findMaximum(int aSize)
    {
        // 
        int j, min = 0;
        for (j = 0; j < aSize; j++)
        {
            if( a[j] > a[min] )
            {
                min = j;
            }
        }
        return min;
    }    

    /**
     * findMaximum
     * 
     * @param  lower   the lowest position to check
     * @param  upper   the highest position to check
     * 
     *  @return min position of the maximum value in the range
     */

    
    public int findMaximum(int lower, int upper)
    {
        // 
        int min = lower;
        for (int j = lower; j <=upper; j++)
        {
            if( a[j] > a[min] )
            {
                min = j;
            }
        }
        return min;
    }    



    public void fill(int aSize)
    {    
       Random generator = new Random(); 
       for (int i = 0; i < aSize; i++) 
       { 
         a[i] = generator.nextDouble(); 
       }
     }
 
     
    public void fill()
    {    
       Random generator = new Random(); 
       for (int i = 0; i < a.length; i++) 
       { 
         a[i] = generator.nextDouble(); 
       }
     }
     
     
    public void printOut()
    {    
       for (int i = 0; i < a.length; i++) 
       { 
         System.out.println(a[i]); 
       }
       System.out.println();
     }
     
    /**
     * sortDouble
     * 
     * implements selection sort
     * 
     */
    public void sortDouble()
    {
        for (int i = 0; i < a.length; i++)
        {
            int min = findMinimum(a, i);
            swap(a, i, min);
         }
    }
    
    /**
     * findMinimum
     * 
     * @param  a   a double array
     * @param  i   the current position in a
     * 
     *  @return min position of the minimum value 
     */
    private int findMinimum(double[] a, int i)
    {
        // 
        int j, min = i;
        for (j = i+1; j < a.length; j++)
        {
            if( a[j] < a[min] )
            {
                min = j;
            }
        }
        return min;
     }
    /**
     * 
     * Swap
     * 
     * @param a   double array
     * @param i,j the positions to swap
     * 
     */
    private void swap(double[] a, int i, int j)
    {
        double temp = a[i];
        a[i] = a[j];
        a[j] = temp;
    }
    
} 